#include "burnergui.h"
#include "cdburner.h"
#include "cancelburndialog.h"

extern CDburner *burnprocess;

BurnerGUI::BurnerGUI(){

}

BurnerGUI::~BurnerGUI(){
  gtk_widget_destroy(burndialog);
}

GtkWidget* BurnerGUI::burnDialog(){
  burndialog = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (burndialog), "Disc Burner");
  gtk_window_set_position (GTK_WINDOW (burndialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (burndialog), TRUE);

  burn_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (burn_vbox);
  gtk_container_add (GTK_CONTAINER (burndialog), burn_vbox);

  status_frame = gtk_frame_new (NULL);
  gtk_widget_show (status_frame);
  gtk_box_pack_start (GTK_BOX (burn_vbox), status_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (status_frame), 2);

  status_label = gtk_label_new ("");
  gtk_widget_show (status_label);
  gtk_container_add (GTK_CONTAINER (status_frame), status_label);
  gtk_widget_set_size_request (status_label, 0, -1);
  gtk_label_set_justify (GTK_LABEL (status_label), GTK_JUSTIFY_LEFT);

  slabel = gtk_label_new ("Status:");
  gtk_widget_show (slabel);
  gtk_frame_set_label_widget (GTK_FRAME (status_frame), slabel);
  gtk_label_set_justify (GTK_LABEL (slabel), GTK_JUSTIFY_LEFT);

  process_frame = gtk_frame_new (NULL);
  gtk_widget_show (process_frame);
  gtk_box_pack_start (GTK_BOX (burn_vbox), process_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (process_frame), 2);

  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow);
  gtk_container_add (GTK_CONTAINER (process_frame), scrolledwindow);
  gtk_widget_set_size_request (scrolledwindow, 340, 230);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  process_textview = gtk_text_view_new ();
  gtk_widget_show (process_textview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow), process_textview);

  output_label = gtk_label_new ("Process Output:");
  gtk_widget_show (output_label);
  gtk_frame_set_label_widget (GTK_FRAME (process_frame), output_label);
  gtk_label_set_justify (GTK_LABEL (output_label), GTK_JUSTIFY_LEFT);

  buttom_frame = gtk_frame_new (NULL);
  gtk_widget_show (buttom_frame);
  gtk_box_pack_start (GTK_BOX (burn_vbox), buttom_frame, FALSE, TRUE, 0);

  buttom_hbox = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (buttom_hbox);
  gtk_container_add (GTK_CONTAINER (buttom_frame), buttom_hbox);
  gtk_container_set_border_width (GTK_CONTAINER (buttom_hbox), 2);

  burn_cancel_button = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (burn_cancel_button);
  gtk_box_pack_start (GTK_BOX (buttom_hbox), burn_cancel_button, FALSE, FALSE, 0);

  burn_done_button = gtk_button_new ();
  gtk_widget_show (burn_done_button);
  gtk_box_pack_start (GTK_BOX (buttom_hbox), burn_done_button, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (burn_done_button, FALSE);

  done_alignment = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (done_alignment);
  gtk_container_add (GTK_CONTAINER (burn_done_button), done_alignment);

  done_hbox = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (done_hbox);
  gtk_container_add (GTK_CONTAINER (done_alignment), done_hbox);

  okimage = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (okimage);
  gtk_box_pack_start (GTK_BOX (done_hbox), okimage, FALSE, FALSE, 0);

  donelabel = gtk_label_new_with_mnemonic ("_Done");
  gtk_widget_show (donelabel);
  gtk_box_pack_start (GTK_BOX (done_hbox), donelabel, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (donelabel), GTK_JUSTIFY_LEFT);

  g_signal_connect ((gpointer) burndialog, "delete_event",
                    G_CALLBACK (on_burn_delete_event), this);
  g_signal_connect ((gpointer) burn_cancel_button, "clicked",
                    G_CALLBACK (on_burn_cancel_clicked), this);
  g_signal_connect ((gpointer) burn_done_button, "clicked",
                    G_CALLBACK (on_burn_done_clicked), this);

  return burndialog;
}

gboolean on_burn_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data){  
  if(burnprocess->burnProcessDone){
    gtk_widget_set_sensitive (((BurnerGUI*)user_data)->burn_done_button, false);
    gtk_widget_set_sensitive (((BurnerGUI*)user_data)->burn_cancel_button, true);
    gtk_widget_hide(((BurnerGUI*)user_data)->burndialog); 
    return true;
  }
  else{
    BasicDialog * canburndia = cancelburndialog();
    canburndia->setTransientFor(GTK_WINDOW(((BurnerGUI*)user_data)->burndialog));
    burnprocess->bCancel = true;
    return true;
  }
}


void on_burn_cancel_clicked(GtkButton *button, gpointer user_data){
  if(burnprocess->burnProcessDone){
    gtk_widget_set_sensitive (((BurnerGUI*)user_data)->burn_done_button, false);
    gtk_widget_set_sensitive (((BurnerGUI*)user_data)->burn_cancel_button, true);
    gtk_widget_hide(((BurnerGUI*)user_data)->burndialog); 
  }
  else{  
    BasicDialog *canburndia = cancelburndialog();
    canburndia->setTransientFor(GTK_WINDOW(((BurnerGUI*)user_data)->burndialog));
    burnprocess->bCancel = true;
  }
}

void on_burn_done_clicked(GtkButton *button, gpointer user_data){
  gtk_widget_set_sensitive (((BurnerGUI*)user_data)->burn_done_button, false);
  gtk_widget_set_sensitive (((BurnerGUI*)user_data)->burn_cancel_button, true);
  gtk_widget_hide(((BurnerGUI*)user_data)->burndialog); 
}
