#ifndef CDBURNER_H
#define CDBURNER_H
#include <gtk/gtk.h>
#include <string>
#include "process.h"
#include "processwatch.h"
#include "burnergui.h"

using namespace std;

class Disc;
class DiscView;

enum {
  s_start,
  s_rmiso,
  s_newdisc,
  s_makeiso,
  s_getdisc,
  s_blank,
  s_burning,
  s_done,
  s_cancel,
  s_nothing
};

class CDburner{
 public:
  CDburner();
  ~CDburner();
  void initBurnProcess(DiscView* theDiscs);
  void burnProcess(int _state);
  int makeISOfile();
  int requireDisc();
  int burnDisc();
  int blankDisc();
  int burnDone();
  int burnCancel();
  int burnStart();
  void setGtkItems(GtkTextView* _textview, GtkLabel* _statuslabel, GtkButton* _donebutton, GtkButton* _cancelbutton, GtkScrolledWindow* _swindow);
  int mkisofsProcessSetup(Disc* theDisc);
  int cdrecordProcessSetup(string _isoname);
  int blankProcessSetup();
  int ejectProcessSetup();
  int deleteProcessSetup();
  void setStatus(string _status);
  void startNewDisc();
  Process mkisofs;
  Process cdrecord;
  Process eject;
  Process blank;
  Process delfile;
  Process diskload;
  Process diskunload;
  GtkTextView* process_textview;
  GtkTextTagTable* texttagtable;
  GtkTextBuffer* textbuffer;
  GtkLabel* statuslabel;
  GtkButton* donebutton;
  GtkButton* cancelbutton;
  GtkScrolledWindow* scrollwindow;
  DiscView* theDiscs;
  bool bInsertdisc;
  bool bCancel;
  int currentDisc;
  string isofname;
  int currentState;
  int stateOnError;
  ProcessWatch theProcesses;
  bool burnProcessDone;
  BurnerGUI *burnergui;
};

#endif
