#ifndef DISCUTILS_H
#define DISCUTILS_H
#include <gtk/gtk.h>
#include <vector>
#include <string>

using namespace std;

class Folder;
class File;

enum{
  t_cdrw,
  t_cdr,
  t_dvdr
};


class Disc{
 public:
  Disc();
  ~Disc();
  GtkWidget *create_disc (int discnumber);
  GtkWidget *fixed;
  GtkWidget *discframe;
  GtkWidget *progressbar;
  GtkWidget *radiobutton;
  GtkTreeModel *model;
  GtkTreeSelection *selection;
  GtkTreeIter iter;
  vector<Folder*> vFolders;
  bool activeDisc;
  string discName;
  double discSize;
  double discSizeMB;
  double discSpaceLeft;
  int discType;
  void updateProgressbar();
  void updateAssignedFolders();
  void applyModel(GtkTreeView *tree_view);
  void addFolder(Folder *nFolder);
  int haveSpaceForFolder(Folder *nFolder);
  void removeFolder(Folder *nFolder);
  void removeFolders();
  void removeSelected();
  void renameSelected(string _burnPath);
  string getSelectedPath();
  void setBurnPath(Folder *nFolder);
  Folder *findIter(GtkTreeIter _iter);
  char *getName();
  void setName(string _name);
  void setSize(double _size, bool _force);
  void setType(int _type);
  double getSize();
  int writeToFile(File *outfile);
  int createFromFile(File *infile);
};

class DiscView{
 public:
  DiscView(GtkTreeView *tree_view_disc, GtkWidget *vbox_disclist);
  ~DiscView();
  void applyModel();
  void removeSelected();
  void renameSelected(string _burnPath);
  void getSelectedPath();
  Disc *getActiveDisc();
  int addDisc(bool _edit);
  int removeDisc();
  int editDisc(Disc *_disc);
  int editDisc();
  void resizeDiscs(int width);
  void radioButtonEvent(GtkRadioButton *button);
  void guiSetActive(bool _state);
  GtkCellRenderer *folderimage_renderer;
  GtkCellRenderer *folder_renderer;
  GtkTreeViewColumn *folderimage_column;
  GtkTreeViewColumn *folder_column;
  GtkTreeModel *model;
  vector<Disc*> allDiscs;
  GtkTreeView *tree_view;
  GtkWidget *vbox;
  GSList *radiobutton_group;
  GtkRadioButton *activebutton;
  int discnumber;
  int newdiscsize;
  int newdisctype;
  int curdiscnew;
  int writeToFile(File *outfile);
  int createFromFile(File *infile);
};

void radiobutton_clicked(GtkRadioButton *widget, gpointer user_data);

#endif
