#include "fdialog.h"

void fbutton_delete(GtkButton *button, gpointer user_data){
  delete (FileDialog*)user_data;
}

void fdialog_delete(GtkWidget *dialog, GdkEvent *event, gpointer user_data){
  delete (FileDialog*)user_data;
}

FileDialog::FileDialog(){

}


FileDialog::~FileDialog(){
  gtk_widget_destroy(filedialog);
}

int FileDialog::connectSignal(gpointer sobject, string sname, GCallback fptr){
  g_signal_connect(sobject, sname.c_str(), fptr, this);
}

void FileDialog::showDialog(){
  gtk_widget_show(filedialog);
}

void FileDialog::createDialog(string ftitle, bool fbuttons){
  filedialog = gtk_file_selection_new (ftitle.c_str());
  gtk_container_set_border_width (GTK_CONTAINER (filedialog), 10);
  gtk_window_set_position (GTK_WINDOW (filedialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (filedialog), TRUE);

  if(!fbuttons){
    gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (filedialog));
  }
  ok_button = GTK_FILE_SELECTION (filedialog)->ok_button;
  gtk_widget_show (ok_button);
  gtk_widget_grab_focus(ok_button);
    
  cancel_button = GTK_FILE_SELECTION (filedialog)->cancel_button;
  gtk_widget_show (cancel_button);

  g_signal_connect((gpointer) filedialog, "delete-event",
		   G_CALLBACK (fdialog_delete),this);

}
