#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "maingui.h"
#include "discutils.h"
#include "folderutils.h"
#include "project.h"
#include "bdialog.h"
#include "setup.h"
#include "cdburner.h"
#include "quitdialog.h"
#include "openprojectdialog.h"
#include "newprojectdialog.h"
#include "dowesavedialog.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <iostream>

using namespace std;

static int resized = 0;
extern Project *project;
extern Setup *setup;
extern CDburner *burnprocess;

MainGUI::MainGUI(){
  
}

MainGUI::~MainGUI(){
  gtk_widget_destroy(discomatic);
}


GtkWidget* MainGUI::createDiscomatic(){
  accel_group = gtk_accel_group_new ();

  discomatic = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (discomatic, 800, 600);
  gtk_window_set_title (GTK_WINDOW (discomatic), "Disc-O-Matic");
  gtk_window_set_position (GTK_WINDOW (discomatic), GTK_WIN_POS_CENTER);

  vbox_main = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_main);
  gtk_container_add (GTK_CONTAINER (discomatic), vbox_main);

  menu_main = gtk_menu_bar_new ();
  gtk_widget_show (menu_main);
  gtk_box_pack_start (GTK_BOX (vbox_main), menu_main, FALSE, FALSE, 0);

  project_item = gtk_menu_item_new_with_mnemonic ("_File");
  gtk_widget_show (project_item);
  gtk_container_add (GTK_CONTAINER (menu_main), project_item);

  project_item_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (project_item), project_item_menu);

  new_project_item = gtk_image_menu_item_new_from_stock ("gtk-new", accel_group);
  gtk_widget_show (new_project_item);
  gtk_container_add (GTK_CONTAINER (project_item_menu), new_project_item);

  open_project_item = gtk_image_menu_item_new_from_stock ("gtk-open", accel_group);
  gtk_widget_show (open_project_item);
  gtk_container_add (GTK_CONTAINER (project_item_menu), open_project_item);

  save_project_item = gtk_image_menu_item_new_from_stock ("gtk-save", accel_group);
  gtk_widget_show (save_project_item);
  gtk_container_add (GTK_CONTAINER (project_item_menu), save_project_item);
  gtk_widget_set_sensitive (save_project_item, FALSE);

  save_project_as_item = gtk_image_menu_item_new_from_stock ("gtk-save-as", accel_group);
  gtk_widget_show (save_project_as_item);
  gtk_container_add (GTK_CONTAINER (project_item_menu), save_project_as_item);
  gtk_widget_set_sensitive (save_project_as_item, FALSE);

  separatormenuitem1 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem1);
  gtk_container_add (GTK_CONTAINER (project_item_menu), separatormenuitem1);
  gtk_widget_set_sensitive (separatormenuitem1, FALSE);

  setup_item = gtk_image_menu_item_new_with_mnemonic ("S_etup");
  gtk_widget_show (setup_item);
  gtk_container_add (GTK_CONTAINER (project_item_menu), setup_item);

  image54 = gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image54);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (setup_item), image54);

  separator2 = gtk_menu_item_new ();
  gtk_widget_show (separator2);
  gtk_container_add (GTK_CONTAINER (project_item_menu), separator2);
  gtk_widget_set_sensitive (separator2, FALSE);

  quit = gtk_image_menu_item_new_from_stock ("gtk-quit", accel_group);
  gtk_widget_show (quit);
  gtk_container_add (GTK_CONTAINER (project_item_menu), quit);

  disc_item = gtk_menu_item_new_with_mnemonic ("_Disc");
  gtk_widget_show (disc_item);
  gtk_container_add (GTK_CONTAINER (menu_main), disc_item);

  disc_item_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (disc_item), disc_item_menu);

  new_disc_item = gtk_image_menu_item_new_with_mnemonic ("_New");
  gtk_widget_show (new_disc_item);
  gtk_container_add (GTK_CONTAINER (disc_item_menu), new_disc_item);
  gtk_widget_set_sensitive (new_disc_item, FALSE);

  image55 = gtk_image_new_from_stock ("gtk-cdrom", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image55);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (new_disc_item), image55);

  edit_disc_item = gtk_image_menu_item_new_with_mnemonic ("_Edit");
  gtk_widget_show (edit_disc_item);
  gtk_container_add (GTK_CONTAINER (disc_item_menu), edit_disc_item);
  gtk_widget_set_sensitive (edit_disc_item, FALSE);

  image56 = gtk_image_new_from_stock ("gtk-cdrom", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image56);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (edit_disc_item), image56);

  delete_disc_item = gtk_image_menu_item_new_with_mnemonic ("_Delete");
  gtk_widget_show (delete_disc_item);
  gtk_container_add (GTK_CONTAINER (disc_item_menu), delete_disc_item);
  gtk_widget_set_sensitive (delete_disc_item, FALSE);

  image57 = gtk_image_new_from_stock ("gtk-cdrom", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image57);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (delete_disc_item), image57);

  separator1 = gtk_menu_item_new ();
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (disc_item_menu), separator1);
  gtk_widget_set_sensitive (separator1, FALSE);

  burn_discs_item = gtk_image_menu_item_new_with_mnemonic ("_Burn Discs");
  gtk_widget_show (burn_discs_item);
  gtk_container_add (GTK_CONTAINER (disc_item_menu), burn_discs_item);
  gtk_widget_set_sensitive (burn_discs_item, FALSE);

  image58 = gtk_image_new_from_stock ("gtk-cdrom", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image58);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (burn_discs_item), image58);

  help_item = gtk_menu_item_new_with_mnemonic ("_Help");
  gtk_widget_show (help_item);
  gtk_container_add (GTK_CONTAINER (menu_main), help_item);

  help_item_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help_item), help_item_menu);

  about_item = gtk_menu_item_new_with_mnemonic ("_About");
  gtk_widget_show (about_item);
  gtk_container_add (GTK_CONTAINER (help_item_menu), about_item);

  hpaned_main = gtk_hpaned_new ();
  gtk_widget_show (hpaned_main);
  gtk_box_pack_start (GTK_BOX (vbox_main), hpaned_main, TRUE, TRUE, 0);
  gtk_paned_set_position (GTK_PANED (hpaned_main), 450);

  vpaned_main = gtk_vpaned_new ();
  gtk_widget_show (vpaned_main);
  gtk_paned_pack1 (GTK_PANED (hpaned_main), vpaned_main, FALSE, TRUE);
  gtk_paned_set_position (GTK_PANED (vpaned_main), 200);

  scrolledwindow_disclist = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow_disclist);
  gtk_paned_pack1 (GTK_PANED (vpaned_main), scrolledwindow_disclist, FALSE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_disclist), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  viewport_disclist = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport_disclist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow_disclist), viewport_disclist);
  gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_disclist), GTK_SHADOW_ETCHED_IN);

  frame_disclist = gtk_frame_new (NULL);
  gtk_widget_show (frame_disclist);
  gtk_container_add (GTK_CONTAINER (viewport_disclist), frame_disclist);
  gtk_frame_set_shadow_type (GTK_FRAME (frame_disclist), GTK_SHADOW_IN);

  vbox_disclist = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_disclist);
  gtk_container_add (GTK_CONTAINER (frame_disclist), vbox_disclist);

  label_disclist = gtk_label_new ("Discs");
  gtk_widget_show (label_disclist);
  gtk_frame_set_label_widget (GTK_FRAME (frame_disclist), label_disclist);
  gtk_label_set_justify (GTK_LABEL (label_disclist), GTK_JUSTIFY_LEFT);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_paned_pack2 (GTK_PANED (vpaned_main), vbox3, TRUE, TRUE);

  hbox1 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox1, FALSE, FALSE, 0);

  removebutton = gtk_button_new ();
  gtk_widget_show (removebutton);
  gtk_box_pack_start (GTK_BOX (hbox1), removebutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (removebutton, FALSE);

  alignment2 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment2);
  gtk_container_add (GTK_CONTAINER (removebutton), alignment2);

  hbox3 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (alignment2), hbox3);

  image18 = gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image18);
  gtk_box_pack_start (GTK_BOX (hbox3), image18, FALSE, FALSE, 0);

  label2 = gtk_label_new_with_mnemonic ("Remove Folder");
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox3), label2, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);

  renamebutton = gtk_button_new ();
  gtk_widget_show (renamebutton);
  gtk_box_pack_start (GTK_BOX (hbox1), renamebutton, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (renamebutton, FALSE);

  alignment3 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (renamebutton), alignment3);

  hbox4 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (alignment3), hbox4);

  image19 = gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image19);
  gtk_box_pack_start (GTK_BOX (hbox4), image19, FALSE, FALSE, 0);

  remamebutton = gtk_label_new_with_mnemonic ("Rename Folder");
  gtk_widget_show (remamebutton);
  gtk_box_pack_start (GTK_BOX (hbox4), remamebutton, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (remamebutton), GTK_JUSTIFY_LEFT);

  frame_discview = gtk_frame_new (NULL);
  gtk_widget_show (frame_discview);
  gtk_box_pack_start (GTK_BOX (vbox3), frame_discview, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame_discview), GTK_SHADOW_IN);

  scrolledwindow_discview = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow_discview);
  gtk_container_add (GTK_CONTAINER (frame_discview), scrolledwindow_discview);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_discview), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_discview), GTK_SHADOW_ETCHED_IN);

  treeview_discview = gtk_tree_view_new ();
  gtk_widget_show (treeview_discview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow_discview), treeview_discview);
  gtk_container_set_border_width (GTK_CONTAINER (treeview_discview), 2);
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_discview), FALSE);

  label_discview = gtk_label_new ("Content");
  gtk_widget_show (label_discview);
  gtk_frame_set_label_widget (GTK_FRAME (frame_discview), label_discview);
  gtk_label_set_justify (GTK_LABEL (label_discview), GTK_JUSTIFY_LEFT);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_paned_pack2 (GTK_PANED (hpaned_main), vbox2, TRUE, TRUE);

  frame_folderlist = gtk_frame_new (NULL);
  gtk_widget_show (frame_folderlist);
  gtk_box_pack_start (GTK_BOX (vbox2), frame_folderlist, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame_folderlist), GTK_SHADOW_IN);

  scrolledwindow_folderlist = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow_folderlist);
  gtk_container_add (GTK_CONTAINER (frame_folderlist), scrolledwindow_folderlist);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_folderlist), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_folderlist), GTK_SHADOW_ETCHED_IN);

  treeview_folderlist = gtk_tree_view_new ();
  gtk_widget_show (treeview_folderlist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow_folderlist), treeview_folderlist);
  gtk_container_set_border_width (GTK_CONTAINER (treeview_folderlist), 2);
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_folderlist), FALSE);

  label_folderlist = gtk_label_new ("Folders");
  gtk_widget_show (label_folderlist);
  gtk_frame_set_label_widget (GTK_FRAME (frame_folderlist), label_folderlist);
  gtk_label_set_justify (GTK_LABEL (label_folderlist), GTK_JUSTIFY_LEFT);

  g_signal_connect ((gpointer) discomatic, "delete_event",
                    G_CALLBACK (on_discomatic_delete_event),
                    NULL);
  g_signal_connect ((gpointer) new_project_item, "activate",
                    G_CALLBACK (on_new_activate),
                    NULL);
  g_signal_connect ((gpointer) open_project_item, "activate",
                    G_CALLBACK (on_open_activate),
                    NULL);
  g_signal_connect ((gpointer) save_project_item, "activate",
                    G_CALLBACK (on_save_activate),
                    NULL);
  g_signal_connect ((gpointer) save_project_as_item, "activate",
                    G_CALLBACK (on_save_as_activate),
                    NULL);
  g_signal_connect ((gpointer) setup_item, "activate",
                    G_CALLBACK (on_setup_item_activate),
                    NULL);
  g_signal_connect ((gpointer) quit, "activate",
                    G_CALLBACK (on_quit_activate),
                    NULL);
  g_signal_connect ((gpointer) disc_item, "activate",
                    G_CALLBACK (on_disc_entry_activate),
                    NULL);
  g_signal_connect ((gpointer) new_disc_item, "activate",
                    G_CALLBACK (on_new_disc_item_activate),
                    NULL);
  g_signal_connect ((gpointer) edit_disc_item, "activate",
                    G_CALLBACK (on_edit_disc_item_activate),
                    NULL);
  g_signal_connect ((gpointer) delete_disc_item, "activate",
                    G_CALLBACK (on_delete_disc_item_activate),
                    NULL);
  g_signal_connect ((gpointer) burn_discs_item, "activate",
                    G_CALLBACK (on_burn_discs_item_activate),
                    NULL);
  g_signal_connect ((gpointer) about_item, "activate",
                    G_CALLBACK (on_about_activate),
                    NULL);
  g_signal_connect ((gpointer) viewport_disclist, "size_allocate",
                    G_CALLBACK (on_viewport_disclist_size_allocate),
                    NULL);
  g_signal_connect ((gpointer) removebutton, "clicked",
                    G_CALLBACK (on_removebutton_clicked),
                    NULL);
  g_signal_connect ((gpointer) renamebutton, "clicked",
                    G_CALLBACK (on_renamebutton_clicked),
                    NULL);

  gtk_window_add_accel_group (GTK_WINDOW (discomatic), accel_group);

  return discomatic;
}

void on_new_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->nextProjectState = 1;
    dowesavedialog();
  }
  else{
    newprojectdialog();
  }
}


void on_open_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->nextProjectState = 2;
    dowesavedialog();
  }
  else{
    openprojectdialog();
  }
}

void on_save_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->save();
  }
}


void on_save_as_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->saveas();
  }
}


void on_quit_activate(GtkMenuItem *menuitem, gpointer user_data){
  quitdialog();
}


void on_disc_entry_activate(GtkMenuItem *menuitem, gpointer user_data){

}


void on_new_disc_item_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->discView->newdisctype = t_cdrw;
    project->discView->newdiscsize = 700;
    project->discView->addDisc(true);
  }
}
void  on_delete_disc_item_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->discView->removeDisc();
  }
}

void on_edit_disc_item_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    project->discView->editDisc();
  }
}

void on_burn_discs_item_activate(GtkMenuItem *menuitem, gpointer user_data){
  if(project){
    burnprocess->initBurnProcess(project->discView);
  }
}

void on_about_activate(GtkMenuItem *menuitem, gpointer user_data){

}

gboolean on_discomatic_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data){
  quitdialog();
  return 1;
}

void on_viewport_disclist_size_allocate(GtkWidget *widget, GdkRectangle *alloc, gpointer user_data){
  if(project){
    if(!resized){ 
      project->discView->resizeDiscs(alloc->width);
      resized = 1;
    }
    else{
      resized = 0;
    }
  }
}

void on_removebutton_clicked(GtkButton *button, gpointer user_data){
  if(project){
    project->discView->removeSelected();
  }
}

void on_renamebutton_clicked(GtkButton *button, gpointer user_data){
  if(project){
    project->discView->getSelectedPath();
  } 
}

void on_setup_item_activate(GtkMenuItem *menuitem, gpointer user_data){
  gtk_widget_show(setup->setupdialog);
}
