#include "openprojectdialog.h"
#include <sys/stat.h>
#include "project.h"
#include "projecterrordialog.h"

extern Project *project;

FileDialog* openprojectdialog(){
  FileDialog* openprojectdialog = new FileDialog();
  openprojectdialog->createDialog("Select Project File", false);
  openprojectdialog->connectSignal(openprojectdialog->cancel_button, 
				   "clicked", G_CALLBACK(fbutton_delete));
  openprojectdialog->connectSignal(openprojectdialog->ok_button, 
				  "clicked", G_CALLBACK(on_openproject_ok_clicked));
  openprojectdialog->showDialog();
  return openprojectdialog;
}


void on_openproject_ok_clicked (GtkButton *button, gpointer user_data){
  GtkWidget *opendia = ((FileDialog*)user_data)->filedialog;
  string filename = (char*)gtk_file_selection_get_filename((GtkFileSelection*)opendia);
  
  
  struct stat buf;
  if((stat(filename.c_str(), &buf)) != 0){
    projecterrordialog();
    return;
  }
  else{
    if(!S_ISREG(buf.st_mode)){
      return;
    }
  }
     
  if(project){
    delete project;
  }

  project = new Project();
  project->createFromFile(filename);
  if(project->fileError){
    projecterrordialog();
    delete project;
    project = NULL;
    return;
  }
  delete (FileDialog*)user_data;
}
