#include "processwatch.h"
#include "process.h"
#include "cdburner.h"
#include "burnerrordialog.h"
#include <gtk/gtk.h>

gboolean process_watch(gpointer data){
  if(((ProcessTimeout*)data)->theProcess->checkProcess()){
    int error = ((ProcessTimeout*)data)->theProcess->closeProcess();
    return ((ProcessTimeout*)data)->parent->removeProcess((ProcessTimeout*)data, error);
  }
  else{
    return true;
  }
}

ProcessTimeout::ProcessTimeout(Process *_theProcess){
  theProcess = _theProcess;
}

void ProcessTimeout::addTimeout(int _nextState){
  stateOnClose = _nextState;
  time_tag = g_timeout_add(500,process_watch,this);
}

void ProcessWatch::setCDBurner(CDburner *parent){
  burnerParent = parent;
}


void ProcessWatch::addProcess(Process *_theProcess, int _nextState){
  ProcessTimeout *newProcess = new ProcessTimeout(_theProcess);
  newProcess->addTimeout(_nextState);
  newProcess->parent = this;
  theProcesses.push_back(newProcess);
}

int ProcessWatch::removeProcess(ProcessTimeout *_theProcess, int error){
  int nextState = _theProcess->stateOnClose;
  
  killProcess(_theProcess);
  
  if(error){
    cout << "Subprocess error code: " << error << "\n";
    burnerrordialog();
    burnerParent->stateOnError = nextState;
  }
  else{
    burnerParent->burnProcess(nextState);
  }
  return false;
}

void ProcessWatch::killProcess(ProcessTimeout *_theProcess){
  g_source_remove(_theProcess->time_tag);
  int i = 0;
  
  while(i < theProcesses.size()){
    if(_theProcess == theProcesses[i]){
      break;
    }
    i++;
  }
  
  if(i < theProcesses.size()){
    theProcesses.erase(theProcesses.begin() + i);
    delete _theProcess;
  }  
}

void ProcessWatch::killAll(){
  for(int i = 0; i < theProcesses.size(); i++){
    Process* deadProcessWalking =  theProcesses[i]->theProcess;
    killProcess(theProcesses[i]);
    deadProcessWalking->killProcess();
  }
}
