#ifndef CONFIG_H
#define CONFIG_H

#include <string>
#include <fstream>
#include <vector>
#include <gtk/gtk.h>
#include "setupgui.h" 

using namespace std;

struct twinpair;

enum{
  SETUP_STRING=0,
  SETUP_BOOL=1
};

class SetupOption{
 public:
  SetupOption(int _type, GtkWidget *_gui, string _name);
  void optionSetGUI(GtkWidget *_gui);
  void optionSetValueBool(bool _state);
  void optionSetValueString(string _value);
  void optionSetGUIValue();
  void optionUpdateValue();
  void optionWriteToFile(ofstream *_file);
  GtkWidget *setupGUI;
  int setupType;
  bool bSetupValue;
  string sSetupValue;
  string optionName;
};


class Setup{
 public:
  Setup();
  ~Setup();
  void setupDialog();
  void createSetupValue(int _type, GtkWidget *_gui, string _name);
  SetupOption* findSetupOption(string _name);
  bool getSettingBool(string _name);
  string getSettingString(string _name);
  void loadrcfile(); 
  int create_default_rcfile();
  int read_rcfile();
  int write_rcfile();
  void set_gui_values();
  void update_settings();
  vector<twinpair> configops;
  int set_value(twinpair thePair);
  void read_pair(ifstream *file);
  void toggleburnbot();
  int checkFile(string _filename);
  string findFile(string _filename);
  int checkNeededExecs();
  bool string2bool(string);
  vector<SetupOption*> allOptions;
  string which;

  SetupGUI *setupgui;  
  GtkWidget *setupdialog;
  GtkWidget *burnbot_checkbutton;
  GtkWidget *burnbot_exe_entry;
  GtkWidget *burnbot_load_entry;
  GtkWidget *burnbot_unload_entry;
};

#endif
