#include "setupgui.h"
#include "setup.h"

extern Setup *setup;


SetupGUI::SetupGUI(){

}

SetupGUI::~SetupGUI(){
  gtk_widget_destroy(setupdialog);
}

GtkWidget* SetupGUI::setupDialog(){
  setupdialog = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (setupdialog, 480, 472);
  gtk_window_set_title (GTK_WINDOW (setupdialog), "Setup");
  gtk_window_set_position (GTK_WINDOW (setupdialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (setupdialog), TRUE);
  gtk_window_set_resizable (GTK_WINDOW (setupdialog), FALSE);
  
  setup_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (setup_vbox);
  gtk_container_add (GTK_CONTAINER (setupdialog), setup_vbox);
  
  cdr_frame = gtk_frame_new (NULL);
  gtk_widget_show (cdr_frame);
  gtk_box_pack_start (GTK_BOX (setup_vbox), cdr_frame, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (cdr_frame), GTK_SHADOW_IN);
  
  cdr_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (cdr_vbox);
  gtk_container_add (GTK_CONTAINER (cdr_frame), cdr_vbox);
  
  cdr_path_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (cdr_path_hbox);
  gtk_box_pack_start (GTK_BOX (cdr_vbox), cdr_path_hbox, TRUE, TRUE, 0);

  cdr_path_label = gtk_label_new (" Cdrecord path: ");
  gtk_widget_show (cdr_path_label);
  gtk_box_pack_start (GTK_BOX (cdr_path_hbox), cdr_path_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (cdr_path_label), GTK_JUSTIFY_LEFT);

  cdr_path_entry = gtk_entry_new ();
  gtk_widget_show (cdr_path_entry);
  gtk_box_pack_start (GTK_BOX (cdr_path_hbox), cdr_path_entry, TRUE, TRUE, 0);

  cdr_opt_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (cdr_opt_hbox);
  gtk_box_pack_start (GTK_BOX (cdr_vbox), cdr_opt_hbox, TRUE, TRUE, 0);

  dev_label = gtk_label_new (" CD-burner device: ");
  gtk_widget_show (dev_label);
  gtk_box_pack_start (GTK_BOX (cdr_opt_hbox), dev_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (dev_label), GTK_JUSTIFY_LEFT);

  cdr_dev_entry = gtk_entry_new ();
  gtk_widget_show (cdr_dev_entry);
  gtk_box_pack_start (GTK_BOX (cdr_opt_hbox), cdr_dev_entry, TRUE, TRUE, 0);

  cdr_eject_checkbutton = gtk_check_button_new_with_mnemonic ("Eject after write");
  gtk_widget_show (cdr_eject_checkbutton);
  gtk_box_pack_start (GTK_BOX (cdr_vbox), cdr_eject_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cdr_eject_checkbutton), TRUE);

  cdr_blank_checkbutton = gtk_check_button_new_with_mnemonic ("Blank CDRW's before write");
  gtk_widget_show (cdr_blank_checkbutton);
  gtk_box_pack_start (GTK_BOX (cdr_vbox), cdr_blank_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cdr_blank_checkbutton), TRUE);

  cdr_burnproff_checkbutton = gtk_check_button_new_with_mnemonic ("Enable protection from buffer underruns");
  gtk_widget_show (cdr_burnproff_checkbutton);
  gtk_box_pack_start (GTK_BOX (cdr_vbox), cdr_burnproff_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cdr_burnproff_checkbutton), TRUE);

  cdr_dao_checkbutton = gtk_check_button_new_with_mnemonic ("Disk At Once (DAO)");
  gtk_widget_show (cdr_dao_checkbutton);
  gtk_box_pack_start (GTK_BOX (cdr_vbox), cdr_dao_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cdr_dao_checkbutton), TRUE);

  cdr_label = gtk_label_new ("Cdrecord");
  gtk_widget_show (cdr_label);
  gtk_frame_set_label_widget (GTK_FRAME (cdr_frame), cdr_label);
  gtk_label_set_justify (GTK_LABEL (cdr_label), GTK_JUSTIFY_LEFT);

  mkisofs_frame = gtk_frame_new (NULL);
  gtk_widget_show (mkisofs_frame);
  gtk_box_pack_start (GTK_BOX (setup_vbox), mkisofs_frame, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (mkisofs_frame), GTK_SHADOW_IN);

  mkisofs_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (mkisofs_vbox);
  gtk_container_add (GTK_CONTAINER (mkisofs_frame), mkisofs_vbox);

  mkiso_path_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (mkiso_path_hbox);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_path_hbox, TRUE, TRUE, 0);

  mkiso_path_label = gtk_label_new (" Mkisofs path: ");
  gtk_widget_show (mkiso_path_label);
  gtk_box_pack_start (GTK_BOX (mkiso_path_hbox), mkiso_path_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (mkiso_path_label), GTK_JUSTIFY_LEFT);

  mkiso_path_entry = gtk_entry_new ();
  gtk_widget_show (mkiso_path_entry);
  gtk_box_pack_start (GTK_BOX (mkiso_path_hbox), mkiso_path_entry, TRUE, TRUE, 0);

  mkiso_tmp_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (mkiso_tmp_hbox);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_tmp_hbox, TRUE, TRUE, 0);

  mkiso_tmp_label = gtk_label_new (" Temp ISO path: ");
  gtk_widget_show (mkiso_tmp_label);
  gtk_box_pack_start (GTK_BOX (mkiso_tmp_hbox), mkiso_tmp_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (mkiso_tmp_label), GTK_JUSTIFY_LEFT);

  mkiso_tmp_entry = gtk_entry_new ();
  gtk_widget_show (mkiso_tmp_entry);
  gtk_box_pack_start (GTK_BOX (mkiso_tmp_hbox), mkiso_tmp_entry, TRUE, TRUE, 0);

  mkiso_rr_checkbutton = gtk_check_button_new_with_mnemonic ("Rock Ridge");
  gtk_widget_show (mkiso_rr_checkbutton);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_rr_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mkiso_rr_checkbutton), TRUE);

  mkiso_jl_checkbutton = gtk_check_button_new_with_mnemonic ("Joliet Extension");
  gtk_widget_show (mkiso_jl_checkbutton);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_jl_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mkiso_jl_checkbutton), TRUE);

  mkiso_31c_checkbutton = gtk_check_button_new_with_mnemonic ("31 Charecter ISO-filenames");
  gtk_widget_show (mkiso_31c_checkbutton);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_31c_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mkiso_31c_checkbutton), TRUE);

  mkiso_ap_checkbutton = gtk_check_button_new_with_mnemonic ("Allow ISO-files starting with a period");
  gtk_widget_show (mkiso_ap_checkbutton);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_ap_checkbutton, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mkiso_ap_checkbutton), TRUE);

  mkiso_jll_checkbutton = gtk_check_button_new_with_mnemonic ("Allow 103 character Jolite filenames");
  gtk_widget_show (mkiso_jll_checkbutton);
  gtk_box_pack_start (GTK_BOX (mkisofs_vbox), mkiso_jll_checkbutton, FALSE, FALSE, 0);

  mkisofs_label = gtk_label_new ("Mkisofs");
  gtk_widget_show (mkisofs_label);
  gtk_frame_set_label_widget (GTK_FRAME (mkisofs_frame), mkisofs_label);
  gtk_label_set_justify (GTK_LABEL (mkisofs_label), GTK_JUSTIFY_LEFT);

  burnbot_frame = gtk_frame_new (NULL);
  gtk_widget_show (burnbot_frame);
  gtk_box_pack_start (GTK_BOX (setup_vbox), burnbot_frame, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (burnbot_frame), GTK_SHADOW_IN);

  burnbot_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (burnbot_vbox);
  gtk_container_add (GTK_CONTAINER (burnbot_frame), burnbot_vbox);

  burnbot_checkbutton = gtk_check_button_new_with_mnemonic ("Have Burnbot (CD changer)");
  gtk_widget_show (burnbot_checkbutton);
  gtk_box_pack_start (GTK_BOX (burnbot_vbox), burnbot_checkbutton, FALSE, FALSE, 0);

  bbot_exe_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (bbot_exe_hbox);
  gtk_box_pack_start (GTK_BOX (burnbot_vbox), bbot_exe_hbox, FALSE, FALSE, 0);

  burnbot_exe_label = gtk_label_new (" Burnbot executable: ");
  gtk_widget_show (burnbot_exe_label);
  gtk_box_pack_start (GTK_BOX (bbot_exe_hbox), burnbot_exe_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (burnbot_exe_label), GTK_JUSTIFY_LEFT);

  burnbot_exe_entry = gtk_entry_new ();
  gtk_widget_show (burnbot_exe_entry);
  gtk_box_pack_start (GTK_BOX (bbot_exe_hbox), burnbot_exe_entry, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (burnbot_exe_entry, FALSE);

  bbot_load_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (bbot_load_hbox);
  gtk_box_pack_start (GTK_BOX (burnbot_vbox), bbot_load_hbox, TRUE, TRUE, 0);

  burnbot_load_label = gtk_label_new (" Burnbot load disc command: ");
  gtk_widget_show (burnbot_load_label);
  gtk_box_pack_start (GTK_BOX (bbot_load_hbox), burnbot_load_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (burnbot_load_label), GTK_JUSTIFY_LEFT);

  burnbot_load_entry = gtk_entry_new ();
  gtk_widget_show (burnbot_load_entry);
  gtk_box_pack_start (GTK_BOX (bbot_load_hbox), burnbot_load_entry, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (burnbot_load_entry, FALSE);

  bbot_unload_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (bbot_unload_hbox);
  gtk_box_pack_start (GTK_BOX (burnbot_vbox), bbot_unload_hbox, TRUE, TRUE, 0);

  burnbot_unload_label = gtk_label_new (" Burnbot unload disc command: ");
  gtk_widget_show (burnbot_unload_label);
  gtk_box_pack_start (GTK_BOX (bbot_unload_hbox), burnbot_unload_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (burnbot_unload_label), GTK_JUSTIFY_LEFT);

  burnbot_unload_entry = gtk_entry_new ();
  gtk_widget_show (burnbot_unload_entry);
  gtk_box_pack_start (GTK_BOX (bbot_unload_hbox), burnbot_unload_entry, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (burnbot_unload_entry, FALSE);

  burnbot_label = gtk_label_new ("Burnbot");
  gtk_widget_show (burnbot_label);
  gtk_frame_set_label_widget (GTK_FRAME (burnbot_frame), burnbot_label);
  gtk_label_set_justify (GTK_LABEL (burnbot_label), GTK_JUSTIFY_LEFT);

  buttom_hbox = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (buttom_hbox);
  gtk_box_pack_start (GTK_BOX (setup_vbox), buttom_hbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (buttom_hbox), 3);

  cancelbutton = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton);
  gtk_box_pack_start (GTK_BOX (buttom_hbox), cancelbutton, FALSE, FALSE, 0);

  okbutton = gtk_button_new ();
  gtk_widget_show (okbutton);
  gtk_box_pack_start (GTK_BOX (buttom_hbox), okbutton, FALSE, FALSE, 0);

  ok_alignment = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (ok_alignment);
  gtk_container_add (GTK_CONTAINER (okbutton), ok_alignment);

  ok_hbox = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (ok_hbox);
  gtk_container_add (GTK_CONTAINER (ok_alignment), ok_hbox);

  applyimage = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (applyimage);
  gtk_box_pack_start (GTK_BOX (ok_hbox), applyimage, FALSE, FALSE, 0);

  apply_label = gtk_label_new_with_mnemonic ("Apply");
  gtk_widget_show (apply_label);
  gtk_box_pack_start (GTK_BOX (ok_hbox), apply_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (apply_label), GTK_JUSTIFY_LEFT);

  g_signal_connect ((gpointer) setupdialog, "delete_event",
                    G_CALLBACK (on_setupdialog_delete_event), this);
  g_signal_connect ((gpointer) burnbot_checkbutton, "toggled",
                    G_CALLBACK (on_burnbot_checkbutton_toggled), this);
  g_signal_connect ((gpointer) cancelbutton, "clicked",
                    G_CALLBACK (on_setup_cancel_clicked), this);
  g_signal_connect ((gpointer) okbutton, "clicked",
                    G_CALLBACK (on_setup_ok_clicked), this);
  
  return setupdialog;
}

void on_setup_cancel_clicked(GtkButton *button, gpointer user_data){
  GtkWidget *setupdialog = ((SetupGUI*)user_data)->setupdialog;
  gtk_widget_hide(setupdialog);
  setup->set_gui_values();
}


void on_setup_ok_clicked(GtkButton *button, gpointer user_data){
  GtkWidget *setupdialog = ((SetupGUI*)user_data)->setupdialog;
  gtk_widget_hide(setupdialog);
  setup->update_settings();
}

void on_burnbot_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data){
  setup->toggleburnbot();
}

gboolean on_setupdialog_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data){
  gtk_widget_hide(setup->setupdialog);
  setup->set_gui_values();
  return 1;
}
